	function addTorrent() {
		var azcomm = Components.classes['@foxtorrent.mozdev.org/azcomm;1'].getService(Components.interfaces.nsIAzComm);
		if (azcomm == null) {
			alert("Could not init AzComm component - check your installation");
			window.close();
			return;
		}
		if (azcomm.connected == false) {
			alert("AzComm component could not make connection - check your settings");
			window.close();
			return;
		}
		var item = document.getElementById('rgTorrentSelection').selectedItem;
		if (item.label == "Torrent URL") {
			var field = document.getElementById('tbURL');
			if (field.value.match(/\.torrent$/))
				azcomm.addURL(field.value);
			else {
				alert("URL is not a torrent file");
				return;
			}
		} else {
			var field = document.getElementById('tbLocalTorrent');
			alert("Adding a local torrent is not implemented yet, sorry");
			return;
		}
		window.close();
	}

	function browseTorrent() {
		var nsIFilePicker = Components.interfaces.nsIFilePicker;
		var fp = Components.classes["@mozilla.org/filepicker;1"].createInstance( nsIFilePicker );
		fp.init( window, "Select a File", nsIFilePicker.modeOpen );
		fp.appendFilter( "Torrent Files", "*.torrent" );
		var res = fp.show();
		if ( res == nsIFilePicker.returnOK ) 
			document.getElementById( "tbLocalTorrent" ).value = fp.file.path;
	}

	function switchTorrentSelection( text ) {
//		if ( text == "Torrent URL" ) {
//			document.getElementById( "tbLocalTorrent" ).setAttribute("disabled","true");
//			document.getElementById( "tbURL" ).setAttribute("disabled", "false");
//		}
//		else {
//			document.getElementById( "tbLocalTorrent" ).setAttribute("disabled","false");
//			document.getElementById( "tbURL" ).setAttribute("disabled","true");
//		}
	}
