
function addTorrent() {
	window.openDialog( "chrome://foxtorrent/content/addTorrent.xul", "windowAddTorrent", 
		"chrome, centerscreen, modal" );
}
function trim(s) {
	return s.replace(/^\s+|\s+$/g,"");
}
function formatSize(s) {
	if (s == null)
		return s;
	else if (s >= 1000000000)
		return (s / 1000000000) + " GB";
	else if (s >= 1000000)
		return (s / 1000000) + " MB";
	else if (s >= 1000)
		return (s / 1000) + " KB";
	return s + " B";
}
function loading() {
	var dls = document.getElementById('lbDownloads');
	var dlli = document.createElement("listitem");
	var dllic1 = document.createElement("listcell");
	var dllic2 = document.createElement("listcell");
	dllic2.setAttribute("orient", "vertical");
	dllic2.setAttribute("align", "left");
	var dllic2l1 = document.createElement("label");
	dllic2l1.setAttribute("value","Loading...");
	dllic2l1.setAttribute("style","font-weight: bold");
	dllic2.appendChild(dllic2l1);
	dlli.appendChild(dllic1);
	dlli.appendChild(dllic2);
	dls.appendChild(dlli);

	var uls = document.getElementById('lbSeeds');
	var ulli = document.createElement("listitem");
	var ullic1 = document.createElement("listcell");
	var ullic2 = document.createElement("listcell");
	ullic2.setAttribute("orient", "vertical");
	ullic2.setAttribute("align", "left");
	var ullic2l1 = document.createElement("label");
	ullic2l1.setAttribute("value","Loading...");
	ullic2l1.setAttribute("style","font-weight: bold");
	ullic2.appendChild(ullic2l1);
	ulli.appendChild(ullic1);
	ulli.appendChild(ullic2);
	uls.appendChild(ulli);
}
function clearLists() {
	var dls = document.getElementById('lbDownloads');
	if (dls != null) {
		for (var i = dls.childNodes.length-1; i >= 0; i--) {
			if (dls.childNodes[i].tagName == "listitem") {
				dls.removeChild(dls.childNodes[i]);
				delete dls.childNodes[i];
			}
		}
	}
	var uls = document.getElementById('lbSeeds');
	if (uls != null) {
		for (var i = uls.childNodes.length-1; i >= 0; i--) {
			if (uls.childNodes[i].tagName == "listitem") {
				uls.removeChild(uls.childNodes[i]);
				delete uls.childNodes[i];
			}
		}
	}
	var pops = document.getElementById('ftpopups');
	if (pops != null) {
		for (var i = pops.childNodes.length - 1; i >= 0; i--) {
			if (pops.childNodes[i].tagName == "tooltip" || pops.childNodes[i].tagName == "menupopup") {
				pops.removeChild(pops.childNodes[i]);
				delete pops.childNodes[i];
			}
		}
	}
}
function populateLists(xmlDoc) {
	if (xmlDoc == null)
		return;
	var dls = document.getElementById('lbDownloads');
	var uls = document.getElementById('lbSeeds');
	var pops = document.getElementById('ftpopups');
	var doc = xmlDoc.documentElement;
	if (doc.childNodes.length == 1)
		doc = doc.firstChild;
	for (var i = 0; i < doc.childNodes.length; i++) {
		if (doc.childNodes[i].tagName == "ENTRY") {
			var subnode = doc.childNodes[i];
			var listitem = document.createElement("listitem");
			var listcell1 = document.createElement("listcell");
			var image = document.createElement("image");
			var listcell2 = document.createElement("listcell");
			listcell2.setAttribute("orient","vertical");
			listcell2.setAttribute("align", "left");
			var namelabel = document.createElement("label");
			namelabel.setAttribute("style", "font-weight: bold");
			var statslabel = document.createElement("label");
			var tooltip = document.createElement("tooltip");
			tooltip.setAttribute("orient","vertical");
			var popup = document.createElement("menupopup");

			var statusstring = "";
//			var force = "";
			var tstatus = "";
			var statsstring = "";
			var ulstring = "";
			var dlstring = ""
			var ttsize = "";
			var ttdlavg = "";
			var ttulavg = "";
			var ttdl = "";
			var ttul = "";
			var ttstatus = "";
			var ttname = "";
			var ttprogress = "";
			var ttseeds = "";
			var ttpeers = "";
			var ttratio = "";
			var ttavail = "";
			var objid = "";
			var icon = "";
			var targ = null;
			for (var j = 0; j < subnode.childNodes.length; j++) {
				switch (subnode.childNodes[j].tagName) {
					case "_object_id":
						objid = trim(subnode.childNodes[j].firstChild.nodeValue);
						listitem.setAttribute("id",objid);
						break;
//					case "force_start":
//						force = trim(subnode.childNodes[j].firstChild.nodeValue);
//						break;
					case "name":
						namelabel.setAttribute("value",trim(subnode.childNodes[j].firstChild.nodeValue));
						break;
					case "scrape_result":
						var subsubnode = subnode.childNodes[j];
						for (var k = 0; k < subsubnode.childNodes.length; k++) {
							switch (subsubnode.childNodes[k].tagName) {
								case "seed_count":
									ttseeds = "Seeds: " + trim(subsubnode.childNodes[k].firstChild.nodeValue);
									break;
								case "non_seed_count":
									ttpeers = "Peers: " + trim(subsubnode.childNodes[k].firstChild.nodeValue);
									break;
							}
						}
						break;
					case "stats":
						var subsubnode = subnode.childNodes[j];
						for (var k = 0; k < subsubnode.childNodes.length; k++) {
							switch (subsubnode.childNodes[k].tagName) {
								case "completed":
									if (trim(subsubnode.childNodes[k].firstChild.nodeValue) == "1000") {
										targ = uls;
									} else {
										targ = dls;
									}
									statsstring += "   Progress: " + (trim(subsubnode.childNodes[k].firstChild.nodeValue) / 10) + "%";
									ttprogress = "Progress: " + (trim(subsubnode.childNodes[k].firstChild.nodeValue) / 10) + "%";
									break;
								case "download_average":
									var sz = formatSize(trim(subsubnode.childNodes[k].firstChild.nodeValue)) + "/s";
									dlstring += "   Download rate: " + sz;
									ttdlavg = "Download rate: " + sz;
									break;
								case "upload_average":
									var sz = formatSize(trim(subsubnode.childNodes[k].firstChild.nodeValue)) + "/s";
									ulstring += "   Upload rate: " + sz;
									ttulavg = "Upload rate: " + sz;
									break;
								case "downloaded":
									ttdl = "Downloaded: " + formatSize(trim(subsubnode.childNodes[k].firstChild.nodeValue));
									break;
								case "uploaded":
									ttul = "Uploaded: " + formatSize(trim(subsubnode.childNodes[k].firstChild.nodeValue));
									break;
								case "status":
									tstatus = trim(subsubnode.childNodes[k].firstChild.nodeValue);
									statusstring += trim(subsubnode.childNodes[k].firstChild.nodeValue);
									ttstatus = "Status: " + trim(subsubnode.childNodes[k].firstChild.nodeValue);
									break;
								case "share_ratio":
									ttratio = "Share Ratio: " + trim(subsubnode.childNodes[k].firstChild.nodeValue);
									break;
								case "availability":
									ttavail = "Availability: " + trim(subsubnode.childNodes[k].firstChild.nodeValue);
									break;
							}
						}
						break;
					case "torrent":
						var subsubnode = subnode.childNodes[j];
						for (var k = 0; k < subsubnode.childNodes.length; k++) {
							switch (subsubnode.childNodes[k].tagName) {
								case "size":
									ttsize = "Size: " + formatSize(trim(subsubnode.childNodes[k].firstChild.nodeValue));
									break;
								case "name":
									ttname = "Name: " + trim(subsubnode.childNodes[k].firstChild.nodeValue);
									break;
							}
						}
						break;
				}
			}
			//alert(targ);
			if (targ != null && objid.length > 0) {
				if (targ == dls) {
					if (tstatus == "Stopped" || tstatus == "Paused") {
					} else
						image.setAttribute("src","chrome://foxtorrent/skin/download.ico");
				} else if (targ == uls) {
					if (tstatus == "Stopped" || tstatus == "Paused")
						image.setAttribute("src","chrome://foxtorrent/skin/completed.ico");
					else
						image.setAttribute("src","chrome://foxtorrent/skin/seed.ico");
				}
				tooltip.setAttribute("id","tt"+objid);
				if (ttname.length > 0) {
					var desc = document.createElement("description");
					desc.setAttribute("value",ttname);
					tooltip.appendChild(desc);
				}
				if (ttstatus.length > 0) {
					var desc = document.createElement("description");
					desc.setAttribute("value",ttstatus);
					tooltip.appendChild(desc);
				}
				if (ttsize.length > 0) {
					var desc = document.createElement("description");
					desc.setAttribute("value",ttsize);
					tooltip.appendChild(desc);
				}
				if (ttul.length > 0) {
					var desc = document.createElement("description");
					desc.setAttribute("value",ttul);
					tooltip.appendChild(desc);
				}
				if (ttdl.length > 0) {
					var desc = document.createElement("description");
					desc.setAttribute("value",ttdl);
					tooltip.appendChild(desc);
				}
				if (ttprogress.length > 0) {
					var desc = document.createElement("description");
					desc.setAttribute("value",ttprogress);
					tooltip.appendChild(desc);
				}
				if (ttdlavg.length > 0) {
					var desc = document.createElement("description");
					desc.setAttribute("value",ttdlavg);
					tooltip.appendChild(desc);
				}
				if (ttulavg.length > 0) {
					var desc = document.createElement("description");
					desc.setAttribute("value",ttulavg);
					tooltip.appendChild(desc);
				}
				if (ttseeds.length > 0) {
					var desc = document.createElement("description");
					desc.setAttribute("value",ttseeds);
					tooltip.appendChild(desc);
				}
				if (ttpeers.length > 0) {
					var desc = document.createElement("description");
					desc.setAttribute("value",ttpeers);
					tooltip.appendChild(desc);
				}
				if (ttratio.length > 0) {
					var desc = document.createElement("description");
					desc.setAttribute("value",ttratio);
					tooltip.appendChild(desc);
				}
				if (ttavail.length > 0) {
					var desc = document.createElement("description");
					desc.setAttribute("value",ttavail);
					tooltip.appendChild(desc);
				}
				pops.appendChild(tooltip);

				popup.setAttribute("id","pop"+objid);
				if (tstatus == "Stopped" || tstatus == "Paused") {
					var item = document.createElement("menuitem");
					item.setAttribute("label","Start");
					item.setAttribute("oncommand","restart('"+objid+"')");
					popup.appendChild(item);
				} else {
					var item = document.createElement("menuitem");
					item.setAttribute("label","Stop");
					item.setAttribute("oncommand","stop('"+objid+"')");
					popup.appendChild(item);
				}
//				if (force == "false") {
//					var item = document.createElement("menuitem");
//					item.setAttribute("label","Force");
//					item.setAttribute("oncommand","force('"+objid+"')");
//					popup.appendChild(item);
//				}
				var sep = document.createElement("menuseparator");
				popup.appendChild(sep);
//				var mtop = document.createElement("menuitem");
//				mtop.setAttribute("label","Move to Top");
//				mtop.setAttribute("oncommand","movetotop('"+objid+"')");
//				popup.appendChild(mtop);
				var mup = document.createElement("menuitem");
				mup.setAttribute("label","Move Up");
				mup.setAttribute("oncommand","moveup('"+objid+"')");
				popup.appendChild(mup);
				var mdown = document.createElement("menuitem");
				mdown.setAttribute("label","Move Down");
				mdown.setAttribute("oncommand","movedown('"+objid+"')");
				popup.appendChild(mdown);
//				var mbot = document.createElement("menuitem");
//				mbot.setAttribute("label","Move to Bottom");
//				mbot.setAttribute("oncommand","movetobottom('"+objid+"')");
//				popup.appendChild(mbot);
				var sep2 = document.createElement("menuseparator");
				popup.appendChild(sep2);
				var rem = document.createElement("menuitem");
				rem.setAttribute("label","Remove");
				rem.setAttribute("oncommand","remove('"+objid+"')");
				popup.appendChild(rem);
				pops.appendChild(popup);

				if (targ == uls)
					statsstring += ulstring;
				else
					statsstring += dlstring;
				statslabel.setAttribute("value",statusstring + statsstring);
				listcell1.appendChild(image);
				listcell2.appendChild(namelabel);
				listcell2.appendChild(statslabel);
				listitem.appendChild(listcell1);
				listitem.appendChild(listcell2);
				listitem.setAttribute("tooltip","tt"+objid);
				listitem.setAttribute("context","pop"+objid);
				targ.appendChild(listitem);
			}
		}
	}
}

var azcomm = null;

function restart(objid) {
	azcomm.restart(objid);
}

function stop(objid) {
	azcomm.stopTorrent(objid);
}

//function force(objid) {
//	azcomm.forceStart(objid);
//}

function movetotop(objid) {
}

function moveup(objid) {
	azcomm.moveUp(objid);
}

function movedown(objid) {
	azcomm.moveDown(objid);
}

function movetobottom(objid) {
}

function remove(objid) {
	azcomm.remove(objid);
}

var FTPane = {
	updateinterval: null,
	getdownloadsinterval: null,
	init: function() {
		azcomm = Components.classes['@foxtorrent.mozdev.org/azcomm;1'].getService(Components.interfaces.nsIAzComm);
		if (azcomm == null) {
			alert("FoxTorrent: Could not init AzComm component - check your installation");
			return;
		}
		if (azcomm.connected == false) {
			alert("FoxTorrent: AzComm component could not make connection - check your settings");
			return;
		}
		this.getDownloads();
		this.update();
		this.getdownloadsinterval = window.setInterval(this.getDownloads, 9*1000);
		this.updateinterval = window.setInterval(this.update, 10*1000);
	},
	uninit: function() {
		window.clearInterval(updateinterval);
		window.clearInterval(getdownloadsinterval);
	},
	getDownloads: function() {
		azcomm.getDownloads();
	},
	update: function() {
		clearLists();
		if (azcomm.downloads == null) {
			loading();
		} else {
			populateLists(azcomm.downloads);
		}
	}
}

window.addEventListener("load", function(e) {FTPane.init();}, false);
window.addEventListener("unload", function(e) {FTPane.uninit();}, false);
